Debian Bug report logs - #571056
chroot_upstart: divert initctl (like policy-rc.d) to fix start(8) in Ubuntu Lucid postinsts.

version graph

Package: live-helper; Maintainer for live-helper is Debian Live Project <debian-live@lists.debian.org>;

Reported by: "Trent W. Buck" <trentbuck@gmail.com>

Date: Tue, 23 Feb 2010 02:51:01 UTC

Severity: normal

Found in version live-helper/2.0~a7-1

Fixed in version live-helper/2.0~a9-1

Done: Daniel Baumann <daniel@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#571056; Package live-helper. (Tue, 23 Feb 2010 02:51:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Trent W. Buck" <trentbuck@gmail.com>:
New Bug report received and forwarded. Copy sent to Debian Live <debian-live@lists.debian.org>. (Tue, 23 Feb 2010 02:51:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: "Trent W. Buck" <trentbuck@gmail.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: chroot_upstart: divert initctl (like policy-rc.d) to fix start(8) in Ubuntu Lucid postinsts.
Date: Tue, 23 Feb 2010 13:47:02 +1100
Package: live-helper
Version: 2.0~a7-1
Severity: normal

See also http://bugs.debian.org/571054 (same issue, in pbuilder).

In chroot_sysv-rc, live-helper currently creates a policy-rc.d that
prevents daemons from starting when they are installed.  This works
well for sysvinit packages.

However, when working with Ubuntu Lucid[0] chroots, many daemons use
upstart instead of sysvinit.  Thus, they ignore policy-rc.d, try (and
fail) to start, further causing dpkg and thus "lh build" to fail.

According to CJ Watson of #ubuntu-devel, this can be done by diverting
/sbin/initctl and substituting a stub.  An example of this can be seen
in debootstrap's "gutsy" script (excerpt below).  Please add something
similar, I guess to /usr/share/live-helper/helpers/chroot_upstart.

        mv "$TARGET/sbin/start-stop-daemon" "$TARGET/sbin/start-stop-daemon.REAL"
        echo \
    "#!/bin/sh
    echo
    echo \"Warning: Fake start-stop-daemon called, doing nothing\"" > "$TARGET/sbin/start-stop-daemon"
        chmod 755 "$TARGET/sbin/start-stop-daemon"

        if [ -x "$TARGET/sbin/initctl" ]; then
          mv "$TARGET/sbin/initctl" "$TARGET/sbin/initctl.REAL"
          echo \
    "#!/bin/sh
    echo
    echo \"Warning: Fake initctl called, doing nothing\"" > "$TARGET/sbin/initctl"
          chmod 755 "$TARGET/sbin/initctl"
        fi

[0] In theory this was an issue with earlier Ubuntu releases, but it
    seems to be far more prevalent in Lucid.

-- Package-specific info:

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'testing'), (500, 'stable')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.26-2-xen-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_AU.utf8, LC_CTYPE=en_AU.utf8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages live-helper depends on:
ii  cdebootstrap                  0.5.5      Bootstrap a Debian system
ii  debootstrap                   1.0.20     Bootstrap a basic Debian system

Versions of packages live-helper recommends:
ii  gettext-base                  0.17-9     GNU Internationalization utilities

Versions of packages live-helper suggests:
ii  dosfstools        3.0.9-1                utilities for making and checking 
ii  fakeroot          1.14.4-1               Gives a fake root environment
ii  genext2fs         1.4.1-2.2              ext2 filesystem generator for embe
ii  genisoimage       9:1.1.10-1             Creates ISO-9660 CD-ROM filesystem
ii  memtest86+        4.00-2.2               thorough real-mode memory tester
ii  mtd-utils [mtd-to 20090606-1             Memory Technology Device Utilities
ii  mtools            4.0.12-1               Tools for manipulating MSDOS files
ii  parted            1.8.8.git.2009.07.19-5 The GNU Parted disk partition resi
ii  squashfs-tools    1:4.0-6                Tool to create and append to squas
ii  sudo              1.7.2p1-1              Provide limited super user privile
ii  syslinux          2:3.83+dfsg-3          utilities for the syslinux bootloa
ii  uuid-runtime      2.16.2-0               runtime components for the Univers
pn  win32-loader      <none>                 (no description available)

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#571056; Package live-helper. (Wed, 24 Feb 2010 01:57:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Trent W. Buck" <trentbuck@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 24 Feb 2010 01:57:02 GMT) Full text and rfc822 format available.

Message #10 received at 571056@bugs.debian.org (full text, mbox):

From: "Trent W. Buck" <trentbuck@gmail.com>
To: 571056@bugs.debian.org
Subject: Re: Bug#571056: chroot_upstart: divert initctl (like policy-rc.d) to fix start(8) in Ubuntu Lucid postinsts.
Date: Wed, 24 Feb 2010 12:54:26 +1100
Trent W. Buck wrote:
> In chroot_sysv-rc, live-helper currently creates a policy-rc.d that
> prevents daemons from starting when they are installed.  This works
> well for sysvinit packages.
>
> However, when working with Ubuntu Lucid[0] chroots, many daemons use
> upstart instead of sysvinit.  Thus, they ignore policy-rc.d, try
> (and fail) to start, further causing dpkg and thus "lh build" to
> fail.
>
> According to CJ Watson of #ubuntu-devel, this can be done by
> diverting /sbin/initctl and substituting a stub.  An example of this
> can be seen in debootstrap's "gutsy" script (excerpt below).  Please
> add something similar, I guess to
> /usr/share/live-helper/helpers/chroot_upstart.

I ran the following in ./helpers/ of the 2.0~a8 source, rebuild and
installed the resulting .deb.  It works for me, so please include it
in the next release.

 sed 's/policy-rc.d/initctl/g; s/sysv-rc/upstart/' chroot_sysv-rc >chroot_upstart
 sed -i '/chroot_sysv-rc/ {p; s/sysv-rc/upstart/g }' chroot binary*
 chmod +x chroot_upstart

PS: I tried to send the literal patch with "git send-email", but
AFAICT it didn't arrive.  The above should be clearer anyway.




Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#571056; Package live-helper. (Wed, 24 Feb 2010 02:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Trent W. Buck" <trentbuck@gmail.com>:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Wed, 24 Feb 2010 02:09:02 GMT) Full text and rfc822 format available.

Message #15 received at 571056@bugs.debian.org (full text, mbox):

From: "Trent W. Buck" <trentbuck@gmail.com>
To: 571056@bugs.debian.org
Cc: "Trent W. Buck" <twb@cybersource.com.au>
Subject: [PATCH 1/3] Appease lintian (typos and roff syntax errors).
Date: Wed, 24 Feb 2010 12:46:31 +1100
From: Trent W. Buck <twb@cybersource.com.au>

---
 manpages/lh_config.en.1 |   16 ++++++++--------
 1 files changed, 8 insertions(+), 8 deletions(-)

diff --git a/manpages/lh_config.en.1 b/manpages/lh_config.en.1
index 3a3e4cf..8a12232 100644
--- a/manpages/lh_config.en.1
+++ b/manpages/lh_config.en.1
@@ -241,7 +241,7 @@ defines which bootloader is beeing used in the generated image. This has only an
 .IP "\fB\-\-bootstrap\fR cdebootstrap|cdebootstrap-static|debootstrap|copy" 4
 defines which program is used to bootstrap the debian chroot, default is debootstrap. Note that if you set the bootstrap program to copy, then your host system is copied. This can be useful if you want to convert/clone your existing host system into a live system, however, make sure you do have enough free space as this can, depending on your host system, get quite big.
 .IP "\fB\-\-bootstrap\-config\fR \fIFILE\fR" 4
-sets a custom configuration file for the boostrap programm of choice and is empty by default. Refere to the documentation of debootstrap or cdebootstrap for more information about that. When the bootstrap program is set to copy, this has no effect.
+sets a custom configuration file for the boostrap program of choice and is empty by default. Refere to the documentation of debootstrap or cdebootstrap for more information about that. When the bootstrap program is set to copy, this has no effect.
 .IP "\-f|\fB\-\-bootstrap\-flavour\fR minimal|standard" 4
 defines if the bootstrap program should bootstrap the standard system (all packages of priority required and important, which is the default) or a minimal system (only packages of priority required, plus apt).
 .IP "\fB\-\-bootstrap\-keyring\fR \fIPACKAGE\fR" 4
@@ -257,9 +257,9 @@ sets which stages should be cached. By default set to bootstrap. As an exception
 .IP "\fB\-\-checksums\fR true|false" 4
 defines if the binary image should contain a file called md5sums.txt that lists all files on the image together with their md5 checksums. This in turn can be used by live-initramfs' built-in integrity-check to verify the medium if specified at boot prompt. In general, this should not be false and is an important feature of live system released to the public. However, during development of very big images it can save some time by not calculating the checksums.
 .IP "\fB\-\-chroot\-build\fR true|false" 4
-defines whetever live-helper should use the tools from within the chroot to build the binary image or not by using and including the host systems tools. This is a very dangerous option, using the tools of the host system can lead to tainted and even non-bootable images if the host systems version of the required tools (mainly these are the bootloaders such as syslinux, grub and yaboot, and the auxilliary tools such as dosfstools, genisoimage, squashfs-tools and others) do not \fBexactely\fR match what is present at build-time in the target distribution. Never do disable this option unless you are \fBexactely\fR sure what you are doing and have \fBcompletely\fI understood its consequences.
+defines whetever live-helper should use the tools from within the chroot to build the binary image or not by using and including the host systems tools. This is a very dangerous option, using the tools of the host system can lead to tainted and even non-bootable images if the host systems version of the required tools (mainly these are the bootloaders such as syslinux, grub and yaboot, and the auxiliary tools such as dosfstools, genisoimage, squashfs-tools and others) do not \fBexactely\fR match what is present at build-time in the target distribution. Never do disable this option unless you are \fBexactely\fR sure what you are doing and have \fBcompletely\fI understood its consequences.
 .IP "\fB\-\-chroot\-filesystem\fR ext2|ext3|squashfs|plain|jffs2" 4
-defines which filesystem type should be used for the root filesystem image. If you use plain, then no filesystem image is created and the root filesystem content is copied on the binary image filesystem as flat files. Depending on what binary filesystem you have choosen, it may not be possible to build with a plain root filesystem, e.g. fat16/fat32 and plain don't work as linux does not support to run on them.
+defines which filesystem type should be used for the root filesystem image. If you use plain, then no filesystem image is created and the root filesystem content is copied on the binary image filesystem as flat files. Depending on what binary filesystem you have chosen, it may not be possible to build with a plain root filesystem, e.g. fat16/fat32 and plain don't work as linux does not support to run on them.
 .IP "\fB\-\-clean\fR" 4
 minimizes config directory by automatically removing unused and thus empty subdirectories.
 .IP "\-c|\fB\-\-conffile\fR \fIFILE\fR" 4
@@ -271,7 +271,7 @@ defines if warnings of debconf should be displayed or not. Warnings from debconf
 .IP "\fB\-\-debconf\-priority\fR low|medium|high|critical" 4
 defines what value the debconf priority shoul dbe set to inside the chroot. By default, it is set to critical, which means that almost no questions are displayed. Note that this only has an effect if you use any debconf frontend different from noninteractive.
 .IP "\fB\-\-debian\-installer\fR true|cdrom|netinst|netboot|businesscard|live|false" 4
-defines which type, if any, of the debian\-installer should be included in the resulting binary image. By default, no installer is included. All available flavours except live are the identical configurations used on the installer media produced by regular debian\-cd. When live is choosen, the live\-installer udeb is included so that debian\-installer will behave different than usual - instead of installing the debian system from packages from the medium or the network, it installs the live system to the disk.
+defines which type, if any, of the debian\-installer should be included in the resulting binary image. By default, no installer is included. All available flavours except live are the identical configurations used on the installer media produced by regular debian\-cd. When live is chosen, the live\-installer udeb is included so that debian\-installer will behave different than usual - instead of installing the debian system from packages from the medium or the network, it installs the live system to the disk.
 .IP "\fB\-\-debian\-installer\-distribution\fR daily|\fICODENAME\fR" 4
 defines the distribution where the debian\-installer files should be taken out from. Normally, this should be set to the same distribution as the live system. However, some times, one wants to use a newer or even daily built installer.
 .IP "\fB\-\-debian\-installer\-preseedfile\fR \fIFILE\fR|\fIURL\fR" 4
@@ -281,7 +281,7 @@ defines if the debian\-installer graphical GTK interface should be true or not.
 .IP "\-d|\fB\-\-distribution\fR \fICODENAME\fR" 4
 defines the distribution of the resulting live system.
 .IP "\-\-\fBdump\fR" 4
-prepares a report of the currently present live system configuration and the version of live\-helper used. This is useful to provide if you submit bug reports, we do get all informations required for us to locate and replicate an error.
+prepares a report of the currently present live system configuration and the version of live\-helper used. This is useful to provide if you submit bug reports, we do get all information required for us to locate and replicate an error.
 .IP "\-e|\fB\-\-encryption\fR false|aes128|aes192|aes256" 4
 defines if the root filesystem should be encrypted or not. By default, this is false.
 .IP "\fB\-\-fdisk\fR fdisk|fdisk.dist" 4
@@ -312,13 +312,13 @@ sets the PUBLISHED field in the header of a resulting CD/DVD image. By default,
 sets the VOLUME field in the header of a resulting CD/DVD and defaults to '(\fIMODE\fR) (\fIDISTRIBUTION\fR) (\fIDATE\fR)' whereas MODE is expanded to the name of the mode in use, DISTRIBUTION the distribution name, and DATE with the current date and time of the generation. When running in debian-release mode however, it will instead default to 'Debian (\fIVERSION\fR) (\fIARCHITECTURE\fR) live' where VERSION becomes the numerical version of the release being built and ARCHITECTURE becomes the name of the architecture.
 .IP "\fB\-\-jffs2\-eraseblock\fR \fISIZE\fR" 4
 sets the eraseblock size for a JFFS2 (Second Journalling Flash File System) filesystem. The default is 64 KiB. If you use an erase block size different than the erase block size of the target MTD device, JFFS2 may not perform optimally. If the SIZE specified is below 4096, the units are assumed to be KiB.
-.IP "[\fB\-\-keyring\-packages\fR \fIPACKAGE\fI|\fI"PACKAGES"\fR" 4
+.IP "[\fB\-\-keyring\-packages\fR \fIPACKAGE\fI|\fI\"PACKAGES\"\fR" 4
 sets the keyring package or additional keyring packages. By default this is set to debian-archive-keyring.
 .IP "\-l|\fB\-\-language\fR \fILANGUAGE\fR" 4
 sets the language of a live system by installing l10n related packages and enables generation of the correct locales through automatically setting the right boot parameters.
-.IP "\-k|\fB\-\-linux\-flavours\fR \fIFLAVOUR\fR|\fI"FLAVOURS"\fR" 4
+.IP "\-k|\fB\-\-linux\-flavours\fR \fIFLAVOUR\fR|\fI\"FLAVOURS\"\fR" 4
 sets the kernel flavours to be installed. Note that in case you specify more than that the first will be configured the default kernel that gets booted.
-.IP "\fB\-\-linux\-packages\fR \fI"PACKAGES"\fR" 4
+.IP "\fB\-\-linux\-packages\fR \fI\"PACKAGES\"\fR" 4
 sets the internal name of the kernel packages naming scheme. If you use debian kernel packages, you will not have to adjust it. If you decide to use custom kernel packages that do not follow the debian naming scheme, remember to set this option to the stub of the packages only (for debian this is linux-image-2.6), so that \fISTUB\fR-\fIFLAVOUR\fR results in a valid package name (for debian e.g. linux-image-2.6-486). Preferably you use the meta package name, if any, for the stub, so that your configuration is ABI independent. Also don't forget that you have to include stubs of the binary modules packages for unionfs or aufs, and squashfs if you built them out-of-tree.
 .IP "\fB\-\-losetup\fR losetup|losetup.orig" 4
 sets the filename of the losetup binary from the host system that should be used. This is autodetected and does generally not need any customization.
-- 
1.6.6.1


From 13de7eb34cb70314c702ff30d21dd351a3296fbf Mon Sep 17 00:00:00 2001
From: Trent W. Buck <twb@cybersource.com.au>
Date: Tue, 23 Feb 2010 16:00:00 +1100
Subject: [PATCH 2/3] Prevent postinsts from starting upstart-based daemons in chroot.
 This patch was auto-generated using the following program:
 sed 's/policy-rc.d/initctl/g; s/sysv-rc/upstart/' chroot_sysv-rc >chroot_upstart
 sed -i '/chroot_sysv-rc/ {p; s/sysv-rc/upstart/g }' chroot binary*

---
 helpers/binary         |    2 +
 helpers/binary_rootfs  |    6 +++
 helpers/chroot         |    2 +
 helpers/chroot_upstart |   86 ++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 96 insertions(+), 0 deletions(-)
 create mode 100644 helpers/chroot_upstart

diff --git a/helpers/binary b/helpers/binary
index 234d898..3dff65a 100755
--- a/helpers/binary
+++ b/helpers/binary
@@ -40,6 +40,7 @@ then
 	lh chroot_resolv install ${*}
 	lh chroot_hostname install ${*}
 	lh chroot_sysv-rc install ${*}
+	lh chroot_upstart install ${*}
 	lh chroot_apt install-binary ${*}
 	lh chroot_sources install ${*}
 fi
@@ -92,6 +93,7 @@ fi
 
 lh chroot_apt remove ${*}
 lh chroot_sysv-rc remove ${*}
+lh chroot_upstart remove ${*}
 lh chroot_sysfs remove ${*}
 lh chroot_selinuxfs remove ${*}
 lh chroot_proc remove ${*}
diff --git a/helpers/binary_rootfs b/helpers/binary_rootfs
index a862895..c33585f 100755
--- a/helpers/binary_rootfs
+++ b/helpers/binary_rootfs
@@ -154,6 +154,7 @@ case "${LH_CHROOT_FILESYSTEM}" in
 					lh chroot_resolv remove ${*}
 					lh chroot_hosts remove ${*}
 					lh chroot_sysv-rc remove ${*}
+					lh chroot_upstart remove ${*}
 					lh chroot_dpkg remove ${*}
 					lh chroot_debianchroot remove ${*}
 					lh chroot_sysfs remove ${*}
@@ -171,6 +172,7 @@ case "${LH_CHROOT_FILESYSTEM}" in
 					lh chroot_debianchroot install ${*}
 					lh chroot_dpkg install ${*}
 					lh chroot_sysv-rc install ${*}
+					lh chroot_upstart install ${*}
 					lh chroot_hosts install ${*}
 					lh chroot_resolv install ${*}
 					lh chroot_hostname install ${*}
@@ -236,6 +238,7 @@ case "${LH_CHROOT_FILESYSTEM}" in
 					lh chroot_resolv remove ${*}
 					lh chroot_hosts remove ${*}
 					lh chroot_sysv-rc remove ${*}
+					lh chroot_upstart remove ${*}
 					lh chroot_dpkg remove ${*}
 					lh chroot_debianchroot remove ${*}
 					lh chroot_sysfs remove ${*}
@@ -253,6 +256,7 @@ case "${LH_CHROOT_FILESYSTEM}" in
 					lh chroot_debianchroot install ${*}
 					lh chroot_dpkg install ${*}
 					lh chroot_sysv-rc install ${*}
+					lh chroot_upstart install ${*}
 					lh chroot_hosts install ${*}
 					lh chroot_resolv install ${*}
 					lh chroot_hostname install ${*}
@@ -351,6 +355,7 @@ case "${LH_CHROOT_FILESYSTEM}" in
 					lh chroot_resolv remove ${*}
 					lh chroot_hosts remove ${*}
 					lh chroot_sysv-rc remove ${*}
+					lh chroot_upstart remove ${*}
 					lh chroot_dpkg remove ${*}
 					lh chroot_debianchroot remove ${*}
 					lh chroot_sysfs remove ${*}
@@ -368,6 +373,7 @@ case "${LH_CHROOT_FILESYSTEM}" in
 					lh chroot_debianchroot install ${*}
 					lh chroot_dpkg install ${*}
 					lh chroot_sysv-rc install ${*}
+					lh chroot_upstart install ${*}
 					lh chroot_hosts install ${*}
 					lh chroot_resolv install ${*}
 					lh chroot_hostname install ${*}
diff --git a/helpers/chroot b/helpers/chroot
index 65c5e65..02a4c04 100755
--- a/helpers/chroot
+++ b/helpers/chroot
@@ -35,6 +35,7 @@ lh chroot_sysfs install ${*}
 lh chroot_debianchroot install ${*}
 lh chroot_dpkg install ${*}
 lh chroot_sysv-rc install ${*}
+lh chroot_upstart install ${*}
 lh chroot_hosts install ${*}
 lh chroot_resolv install ${*}
 lh chroot_hostname install ${*}
@@ -69,6 +70,7 @@ lh chroot_hostname remove ${*}
 lh chroot_resolv remove ${*}
 lh chroot_hosts remove ${*}
 lh chroot_sysv-rc remove ${*}
+lh chroot_upstart remove ${*}
 lh chroot_dpkg remove ${*}
 lh chroot_debianchroot remove ${*}
 lh chroot_sysfs remove ${*}
diff --git a/helpers/chroot_upstart b/helpers/chroot_upstart
new file mode 100644
index 0000000..a963044
--- /dev/null
+++ b/helpers/chroot_upstart
@@ -0,0 +1,86 @@
+#!/bin/sh
+
+# lh_chroot_upstart(1) - manage /usr/sbin/initctl
+# Copyright (C) 2006-2009 Daniel Baumann <daniel@debian.org>
+#
+# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
+# This is free software, and you are welcome to redistribute it
+# under certain conditions; see COPYING for details.
+
+set -e
+
+# Including common functions
+. "${LH_BASE:-/usr/share/live-helper}"/live-helper.sh
+
+# Setting static variables
+DESCRIPTION="$(Echo 'manage /usr/sbin/initctl')"
+HELP=""
+USAGE="${PROGRAM} {install|remove} [--force]"
+
+Arguments "${@}"
+
+# Reading configuration files
+Read_conffiles config/all config/common config/bootstrap config/chroot config/binary config/source
+Set_defaults
+
+# Requiring stage file
+Require_stagefile .stage/config .stage/bootstrap
+
+case "${1}" in
+	install)
+		Echo_message "Configuring file /usr/sbin/initctl"
+
+		# Checking stage file
+		Check_stagefile .stage/chroot_upstart
+
+		# Checking lock file
+		Check_lockfile .lock
+
+		# Creating lock file
+		Create_lockfile .lock
+
+		if [ -f chroot/usr/sbin/initctl ]
+		then
+			# Save initctl file
+			mv chroot/usr/sbin/initctl chroot/usr/sbin/initctl.orig
+		fi
+
+		# Create initctl file
+cat > chroot/usr/sbin/initctl << EOF
+#!/bin/sh
+echo "All runlevel operations denied by policy" >&2
+exit 101
+EOF
+
+		chmod 0755 chroot/usr/sbin/initctl
+
+		# Creating stage file
+		Create_stagefile .stage/chroot_upstart
+		;;
+
+	remove)
+		Echo_message "Deconfiguring file /usr/sbin/initctl"
+
+		# Checking lock file
+		Check_lockfile .lock
+
+		# Creating lock file
+		Create_lockfile .lock
+
+		if [ -f chroot/usr/sbin/initctl.orig ]
+		then
+			# Restore initctl file
+			mv chroot/usr/sbin/initctl.orig chroot/usr/sbin/initctl
+		else
+			# Remove initctl file
+			rm -f chroot/usr/sbin/initctl
+		fi
+
+		# Removing stage file
+		rm -f .stage/chroot_upstart
+		;;
+
+	*)
+		Usage
+		;;
+esac
-- 
1.6.6.1


From 11f829db37aaf88e77b1ee8c1eed915cf2ec942d Mon Sep 17 00:00:00 2001
From: Trent W. Buck <twb@cybersource.com.au>
Date: Tue, 23 Feb 2010 16:05:04 +1100
Subject: [PATCH 3/3] Oops; git isn't DAC-agnostic.

---
 0 files changed, 0 insertions(+), 0 deletions(-)
 mode change 100644 => 100755 helpers/chroot_upstart

diff --git a/helpers/chroot_upstart b/helpers/chroot_upstart
old mode 100644
new mode 100755
-- 
1.6.6.1





Information forwarded to debian-bugs-dist@lists.debian.org, Debian Live <debian-live@lists.debian.org>:
Bug#571056; Package live-helper. (Thu, 04 Mar 2010 13:06:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to daniel@debian.org:
Extra info received and forwarded to list. Copy sent to Debian Live <debian-live@lists.debian.org>. (Thu, 04 Mar 2010 13:06:07 GMT) Full text and rfc822 format available.

Message #20 received at 571056@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 571056-submitter@bugs.debian.org
Cc: 571056@bugs.debian.org
Subject: Re: chroot_upstart: divert initctl (like policy-rc.d) to fix start(8) in Ubuntu Lucid postinsts.
Date: Thu, 04 Mar 2010 13:56:01 +0100
tag 571056 pending
thanks

applied it in git, thanks.

-- 
Address:        Daniel Baumann, Burgunderstrasse 3, CH-4562 Biberist
Email:          daniel.baumann@panthera-systems.net
Internet:       http://people.panthera-systems.net/~daniel-baumann/




Added tag(s) pending. Request was from Daniel Baumann <daniel@debian.org> to control@bugs.debian.org. (Thu, 04 Mar 2010 13:06:09 GMT) Full text and rfc822 format available.

Message sent on to "Trent W. Buck" <trentbuck@gmail.com>:
Bug#571056. (Thu, 04 Mar 2010 13:06:11 GMT) Full text and rfc822 format available.

Reply sent to Daniel Baumann <daniel@debian.org>:
You have taken responsibility. (Sun, 14 Mar 2010 22:48:04 GMT) Full text and rfc822 format available.

Notification sent to "Trent W. Buck" <trentbuck@gmail.com>:
Bug acknowledged by developer. (Sun, 14 Mar 2010 22:48:04 GMT) Full text and rfc822 format available.

Message #30 received at 571056-close@bugs.debian.org (full text, mbox):

From: Daniel Baumann <daniel@debian.org>
To: 571056-close@bugs.debian.org
Subject: Bug#571056: fixed in live-helper 2.0~a9-1
Date: Sun, 14 Mar 2010 22:47:27 +0000
Source: live-helper
Source-Version: 2.0~a9-1

We believe that the bug you reported is fixed in the latest version of
live-helper, which is due to be installed in the Debian FTP archive:

live-helper_2.0~a9-1.diff.gz
  to main/l/live-helper/live-helper_2.0~a9-1.diff.gz
live-helper_2.0~a9-1.dsc
  to main/l/live-helper/live-helper_2.0~a9-1.dsc
live-helper_2.0~a9-1_all.deb
  to main/l/live-helper/live-helper_2.0~a9-1_all.deb
live-helper_2.0~a9.orig.tar.gz
  to main/l/live-helper/live-helper_2.0~a9.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 571056@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Daniel Baumann <daniel@debian.org> (supplier of updated live-helper package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 14 Mar 2010 23:31:59 +0100
Source: live-helper
Binary: live-helper
Architecture: source all
Version: 2.0~a9-1
Distribution: unstable
Urgency: low
Maintainer: Debian Live <debian-live@lists.debian.org>
Changed-By: Daniel Baumann <daniel@debian.org>
Description: 
 live-helper - Debian Live build scripts
Closes: 571056 572976 572983
Changes: 
 live-helper (2.0~a9-1) unstable; urgency=low
 .
   [ Daniel Baumann ]
   * Applying slightly modified patch from Cody A.W. Somerville
     <cody.somerville@canonical.com> to add support for custom debian
     installer images mirror.
 .
   [ Trent W. Buck ]
   * Adding helper to prevent upstart from being run during chroot phase
     (Closes: #571056).
 .
   [ Daniel Baumann ]
   * Adding lh_chroot_upstart manpage.
   * Updating year to 2010 in copyright notices.
   * Adding support for debian-volatile archive.
   * Setting debian-installer-gui default to false for squeeze and sid.
   * Removing outdated crontab and cronjob examples.
   * Merging live-webhelper.
   * Removing obsolete common file in cgi.
   * Updating function reading in the cgi.
   * Updating copyright headers in cgi.
   * Shuffeling cgi files arround.
   * Updating filesystem pathes in cgi.
   * Removing obsolete mechanism of using alternatives for templates, has
     never been used anyway and it's more suitable to directly specify
     them in the config tree instead.
   * Removing obsolete removal of (not used) logfile in the maintainer
     scripts.
   * Excluding cgi from checkbashism (checkbashism is too stupid).
   * Correcting she-bang in cgi.
 .
   [ Steven Shiau ]
   * Fixing build failure with indices caching.
 .
   [ Daniel Baumann ]
   * Only remove auxilliary packages in rootfs when not using pre-cached
     chroot (Closes: #572976).
 .
   [ Richard Nelson ]
   * Removing LH_MIRROR_BOOTSTRAP_SECURITY in the cgi.
   * Cleaning up cgi templates.
   * Updating variables for live-helper 2 in the cgi.
 .
   [ Daniel Baumann ]
   * Adding temporary makefile for the cgi.
 .
   [ Richard Nelson ]
   * Removing etch legacy options in the cgi.
   * Updating booleans for live-helper 2 in the cgi.
   * Updating mail contents in the cgi.
   * Updating cron for live-helper 2 in the cgi.
   * Updating packages lists for live-helper 2 in the cgi.
   * Removing unused version variable in the cgi templates.
   * Updating homepage location in the cgi templates.
 .
   [ Daniel Baumann ]
   * Updating hostname of ubuntu security updates.
   * Adding update repositories as volatile when building in ubuntu mode
     (Closes: #572983).
   * Correcting typo in desktop hacks.
   * Updating rescue list for squeeze.
   * Updating debian-forensics list.
   * Manually removing resolvconf when building kde-desktop release
     images.
   * Updating menu splash image for new syslinux.
   * Updating contact information in copyright file.
   * Updating autobuild script for squeeze alpha1 images.
 .
   [ Richard Nelson ]
   * Clean out trailing white space and tabs on l-h.cgi cron.
   * Added debug option on l-h.cgi cron.
   * Added debug option on l-h.cgi cgi.
   * Clean out leading white space on l-h.cgi cgi.
 .
   [ Daniel Baumann ]
   * Simplifying wording in bug-presubj file.
   * Reordering auto install overrides in rules file.
Checksums-Sha1: 
 eb492770677f4c56f3b22abdc56e190f7f3c8a22 1242 live-helper_2.0~a9-1.dsc
 1ca947f306e076fc287502581cb3eebcf8edc16f 2253784 live-helper_2.0~a9.orig.tar.gz
 3ec5b0f71c1940864c3232afd6c3a89e6edf34d6 30156 live-helper_2.0~a9-1.diff.gz
 2f7986a2780810b63d72aedb895527da49b09d27 1117140 live-helper_2.0~a9-1_all.deb
Checksums-Sha256: 
 65e6932cf8b36a81bc315bd02d89742587f621e6eb97e3b64be87dd3877ea32e 1242 live-helper_2.0~a9-1.dsc
 d62257d18d794b7562a93333670e5410e65feb7118200b5c329b3241ab1422b6 2253784 live-helper_2.0~a9.orig.tar.gz
 7c282ec259207f27b109da88d7e68be5637cce36121262566ebe923d5fb12d35 30156 live-helper_2.0~a9-1.diff.gz
 2d7a814949291d8e71ffc4e529209a5fb84a7ba886189289a36abba9511c2a63 1117140 live-helper_2.0~a9-1_all.deb
Files: 
 6a91aa223c53f3f0e67b877d88ab5834 1242 misc optional live-helper_2.0~a9-1.dsc
 3ccf292b8c31962786658acbc44a0371 2253784 misc optional live-helper_2.0~a9.orig.tar.gz
 ab96721182e5066b0d6869555acc8355 30156 misc optional live-helper_2.0~a9-1.diff.gz
 2fea5136afe7119df610b9c37c38feb1 1117140 misc optional live-helper_2.0~a9-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEARECAAYFAkudZNUACgkQ+C5cwEsrK55XGQCdFAg5wIqvgYLHby0aEYkKPMif
mmcAoNFtCBXVq2dGx32m0D1o+6YXaik4
=NLGW
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 22 Apr 2010 07:36:46 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 23 16:44:38 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.